<!doctype html>
<html lang="en">

<head>
    <title>Task 23B.60</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
        integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"
        integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"
        integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
        crossorigin="anonymous"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.1/jquery.min.js" integrity="sha512-aVKKRRi/Q/YV+4mjoKBsE4x3H+BkegoM/em46NNlCqNTmUYADjBbeNefNxYV7giUp0VxICtqdrbqU7iVaeZNXA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <style>
        .cover-picture {
            background-image: url("LuckyDiceImages/cover.jpg");
            background-repeat: repeat-x;
            height: 100px;
        }

        .div-dice-picture {
            border: 5px solid white;
            border-radius: 5px;
        }
    </style>
</head>
<body>
    <div class="container-fluid form-group">
        <div class="cover-picture"></div>
    </div>
    <div class="container jumbotron">
        <div class="row">
            <div class="col-sm-5">
                <div>
                    <h3>Nhập thông tin của bạn</h3>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Username</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="input-username" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">First Name</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="input-firstname" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Last Name</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="input-lastname" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-sm-4 text-center">
                <div class="col-sm-12 form-group">
                    <button onclick="onBtnDiceClick()" class="btn btn-success w-75">Ném</button>
                </div>
                <div class="col-sm-12 form-group">
                    <div class="div-dice-picture">
                        <img id="img-dice" src="LuckyDiceImages/dice.png" alt="dice-picture" width="100%" class="rounded">
                    </div>
                </div>
                <div id="div-chuc-mung" style="display:none">
                    <p id="p-chuc-mung" style="font-weight:bold">Chúc mừng</p>
                </div>
            </div>
            <div class="col-sm-3 text-center">
                <div>
                    <p id="p-voucher">Voucher</p>
                </div>
                <div>
                    <p id="p-voucher-id">No ID</p>
                </div>
                <div>
                    <p id="p-discount">0%</p>
                </div>
                <div>
                    <img id="img-prize" src="LuckyDiceImages/no-present.jpg" alt="prize" width="100%">
                </div>
            </div>
        </div>
    </div>
    <div class="container jumbotron text-center">
        <div class="row">
            <div class="col-sm-12">
                <button onclick="onBtnDiceHistory()" class="btn btn-primary w-25">Dice History</button>
                <button onclick="onBtnVoucherHistory()" class="btn btn-primary w-25">Voucher History</button>
                <button onclick="onBtnPresentHistory()" class="btn btn-primary w-25">Present History</button>
            </div>
        </div>
        <!-- Bảng dữ liệu Dice History -->
        <div id="tab-dice-history" class="row text-left tab-content" style="display: none">
            <table id="table-dice-history" class="table">
                <thead>
                    <tr>
                        <th>Luợt</th>
                        <th>Dice</th>
                    </tr>
                </thead>
                <tbody id="tbody-dice-history">
                    <tr>
                        <td>1</th>
                        <td>4</th>
                    </tr>
                    <tr>
                        <td>2</th>
                        <td>6</th>
                    </tr><tr>
                        <td>3</th>
                        <td>1</th>
                    </tr>
                </tbody>
            </table>
        </div>
        <!-- Bảng dữ liệu Voucher History -->
        <div id="tab-voucher-history" class="row text-left tab-content" style="display: none">
            <table id="table-voucher-history" class="table">
                <thead>
                    <tr>
                        <th>STT</th>
                        <th>Mã voucher</th>
                        <th>Giảm giá</th>
                        <th>Ghi chú</th>
                    </tr>
                </thead>
                <tbody id="tbody-voucher-history">
                    
                </tbody>
            </table>
        </div>
        <!-- Bảng dữ liệu Prize History -->
        <div id="tab-prize-history" class="row text-left tab-content" style="display: none">
            <table id="table-prize-history" class="table">
                <thead>
                    <tr>
                        <th>STT</th>
                        <th>Phần thưởng</th>
                        <th>Mô tả</th>
                    </tr>
                </thead>
                <tbody id="tbody-prize-history">
                    
                </tbody>
            </table>
        </div>
    </div>
</body>
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://localhost:8000/devcamp-lucky-dice";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_OF_ROW_COL = -1;
    const gCOl_TIME = 0;
    const gCOL_DICE = 1;
    const gCOL_VOUCHER = 1;
    const gCOL_DISCOUNT = 2;
    const gCOL_NOTE = 3;
    const gCOL_PRIZE = 1;
    const gCOL_DESCRIPTION = 2;
    //Hàm xử lý nút Present History
    function onBtnPresentHistory(){
        console.log("Nút Present History được ấn");
        vPersonData = {
            username: "",
            firstname: "",
            lastname: ""
        }
        //Truy xuất dữ liệu
        getPersonDataFromForm(vPersonData);
        console.log(vPersonData);
        //Kiểm tra dữ liệu
        var vCheck = validateData(vPersonData);
        console.log(vCheck);
        if (vCheck==true){
            displayPrizeHistoryTable();
            callAjaxPrizeHistoryOfUser(vPersonData);
        }
    }

    //Hàm xử lý nút Voucher History
    function onBtnVoucherHistory(){
        console.log("Nút Voucher History được ấn");
        vPersonData = {
            username: "",
            firstname: "",
            lastname: ""
        }
        //Truy xuất dữ liệu
        getPersonDataFromForm(vPersonData);
        console.log(vPersonData);
        //Kiểm tra dữ liệu
        var vCheck = validateData(vPersonData);
        console.log(vCheck);
        if (vCheck==true){
            displayVoucherHistoryTable();
            callAjaxVoucherHistoryOfUser(vPersonData);
        }
    }
    
    //Hàm ấn nút Dice history
    function onBtnDiceHistory(){
        console.log("Nút Dice History được ấn");
        vPersonData = {
            username: "",
            firstname: "",
            lastname: ""
        }
        //Truy xuất dữ liệu
        getPersonDataFromForm(vPersonData);
        console.log(vPersonData);
        //Kiểm tra dữ liệu
        var vCheck = validateData(vPersonData);
        console.log(vCheck);
        if (vCheck==true){
            displayDiceHistoryTable();
            var vUserName = vPersonData.username;
            var vXmlHttpDiceHistory = new XMLHttpRequest();
            vXmlHttpDiceHistory.open("GET", gBASE_URL + "/dice-history?username=" + vUserName, true);
            vXmlHttpDiceHistory.send();
            vXmlHttpDiceHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    handleDiceHistoryResponse(vXmlHttpDiceHistory); 
                }
            }
        }
    }
    //Hàm ấn nút ném 
    function onBtnDiceClick(){
        vPersonData = {
            username: "",
            firstname: "",
            lastname: ""
        }
        //Truy xuất dữ liệu
        getPersonDataFromForm(vPersonData);
        console.log(vPersonData);
        //Kiểm tra dữ liệu
        var vCheck = validateData(vPersonData);
        console.log(vCheck);
        if (vCheck==true){
            var vXmlHttpDice = new XMLHttpRequest();
            vXmlHttpDice.open("POST", gBASE_URL + "/dice", true);
            vXmlHttpDice.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
            vXmlHttpDice.send(JSON.stringify(vPersonData));  //chuyển Json object sang string
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    handleDiceResponse(vXmlHttpDice); 
                }
            }
        }
    }
    //Hàm yêu cầu Prize History
    function callAjaxPrizeHistoryOfUser(paramPerson){
        $.ajax({
                url: gBASE_URL + "/prize-history?username="+paramPerson.username,
                type: 'GET',
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vPersonData),
                dataType: 'json',
                success: function(res){
                    console.log(res);
                    handlePrizeHistoryResponse(res);
                },
                error: function(err){
                    console.log(`Error: ${err}`)
                }
            })
    }
    //Hàm xử lý dữ liệu trả về Prize History
    function handlePrizeHistoryResponse(paramPrizeHistory){
        var vPrizeHistory =  paramPrizeHistory.prizes;
        console.log(vPrizeHistory);
        var vTBodyPrizeHistory = document.getElementById("tbody-prize-history");
        for (var bIndex = 0; bIndex < vPrizeHistory.length; bIndex++){
            var vNewRow = vTBodyPrizeHistory.insertRow(gEND_OF_ROW_COL);
            var vCellTime = vNewRow.insertCell(gCOl_TIME);
            var vCellPrize =vNewRow.insertCell(gCOL_PRIZE);
            var vCellDescription =vNewRow.insertCell(gCOL_DESCRIPTION);
            vCellTime.innerHTML = bIndex +1;
            vCellPrize.innerHTML = vPrizeHistory[bIndex].prize.name;
            vCellDescription.innerHTML = vPrizeHistory[bIndex].prize.description;
        }
    }
    //Hàm xử lý hiện thị bảng dữ liệu Prize History
    function displayPrizeHistoryTable(){
        var vTabContent = document.getElementsByClassName("tab-content");
        for (let bIndex = 0; bIndex < vTabContent.length; bIndex++){
            vTabContent[bIndex].style.display = "none";
        }
        var vTabPrizeHistory = document.getElementById("tab-prize-history");
        vTabPrizeHistory.style.display = "block";
        var vTablePrizeHistory = document.getElementById("table-prize-history");
        while (vTablePrizeHistory.rows.length > 1) {
            vTablePrizeHistory.deleteRow(1);
        }
    }
    //Hàm yêu cầu Voucher History User
    function callAjaxVoucherHistoryOfUser(paramPerson){
         $.ajax({
                url: gBASE_URL + "/voucher-history?username="+paramPerson.username,
                type: 'GET',
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vPersonData),
                dataType: 'json',
                success: function(res){
                    console.log(res);
                    handleVoucherHistoryResponse(res);
                },
                error: function(err){
                    console.log(`Error: ${err}`)
                }
            })
    }
    //Hàm xử lý dữ liệu trả về Voucher History
    function handleVoucherHistoryResponse(paramVoucherHistory){
        var vVoucherHistory =  paramVoucherHistory.vouchers;
        console.log(vVoucherHistory);
        var vTBodyVoucherHistory = document.getElementById("tbody-voucher-history");
        for (var bIndex = 0; bIndex < vVoucherHistory.length; bIndex++){
            var vNewRow = vTBodyVoucherHistory.insertRow(gEND_OF_ROW_COL);
            var vCellTime = vNewRow.insertCell(gCOl_TIME);
            var vCellVoucher =vNewRow.insertCell(gCOL_VOUCHER);
            var vCellDiscount =vNewRow.insertCell(gCOL_DISCOUNT);
            var vCellNote =vNewRow.insertCell(gCOL_NOTE);
            vCellTime.innerHTML = bIndex +1;
            vCellVoucher.innerHTML = vVoucherHistory[bIndex].voucher.code;
            vCellDiscount.innerHTML = vVoucherHistory[bIndex].voucher.discount;
            vCellNote.innerHTML = vVoucherHistory[bIndex].voucher.note;
        }
    }
    //Hàm xử lý hiện thị bảng Voucher History
    function displayVoucherHistoryTable(){
        var vTabContent = document.getElementsByClassName("tab-content");
        for (let bIndex = 0; bIndex < vTabContent.length; bIndex++){
            vTabContent[bIndex].style.display = "none";
        }
        var vTabVoucherHistory = document.getElementById("tab-voucher-history");
        vTabVoucherHistory.style.display = "block";
        var vTableVoucherHistory = document.getElementById("table-voucher-history");
        while (vTableVoucherHistory.rows.length > 1) {
            vTableVoucherHistory.deleteRow(1);
        }
    }
    //Hàm xử lý bảng Dice History
    function displayDiceHistoryTable(){
        var vTabContent = document.getElementsByClassName("tab-content");
        for (let bIndex = 0; bIndex < vTabContent.length; bIndex++){
            vTabContent[bIndex].style.display = "none";
        }

        var vTabDiceHistory = document.getElementById("tab-dice-history");
        vTabDiceHistory.style.display = "block";

        var vTableDiceHistory = document.getElementById("table-dice-history");
        while (vTableDiceHistory.rows.length > 1) {
            vTableDiceHistory.deleteRow(1);
        }
    }
    //Hàm xử lý dữ liệu Dice History trả về
    function handleDiceHistoryResponse(paramvXmlHttpDiceHistory){
        console.log(paramvXmlHttpDiceHistory.responseText);
        vDiceHistoryResponse = JSON.parse(paramvXmlHttpDiceHistory.responseText);
        vDiceHistory = vDiceHistoryResponse.dices;
        console.log(vDiceHistoryResponse);
        var vTBodyDiceHistory = document.getElementById("tbody-dice-history");
        for (var bIndex = 0; bIndex < vDiceHistory.length; bIndex++){
            var vNewRow = vTBodyDiceHistory.insertRow(gEND_OF_ROW_COL);
            var vCellTime = vNewRow.insertCell(gCOl_TIME);
            var vCellDice =vNewRow.insertCell(gCOL_DICE);
            vCellTime.innerHTML = bIndex +1;
            vCellDice.innerHTML = vDiceHistory[bIndex].dice;
        }
    }
    //Hàm hiện thị prize
    function displayPrize(paramDiceResponse){
        var vImgPrizeElement = document.getElementById("img-prize");
        var vPrize = paramDiceResponse.prize;
        if (vPrize!=null){
            if(vPrize.name == "Nón"){
                vImgPrizeElement.src = "LuckyDiceImages/hat.jpg"
            }
            if(vPrize.name=="Xe ô tô"){
                vImgPrizeElement.src = "LuckyDiceImages/car.jpg"
            }
            if(vPrize.name=="Xe máy"){
                vImgPrizeElement.src = "LuckyDiceImages/motobike.jpg"
            }
            if(vPrize.name=="Áo"){
                vImgPrizeElement.src = "LuckyDiceImages/t-shirt.jpg"
            }
        }
        else {
            vImgPrizeElement.src = "LuckyDiceImages/no-present.jpg"
        }
    }
    //Hàm hiện thị voucher
    function displayVoucher(paramDiceResponse){
        var vVoucher = paramDiceResponse.voucher;
        if (vVoucher!=null){
            var vVoucherID = vVoucher.code;
            var vDiscount = vVoucher.discount + "%";
            var vPVoucherIdElement = document.getElementById("p-voucher-id");
            vPVoucherIdElement.innerHTML = vVoucherID;
            var vPDiscountIdElement = document.getElementById("p-discount");
            vPDiscountIdElement.innerHTML = vDiscount;
        }
    }
    //Hàm hiện thị lời chúc
    function displayChucMung(paramDice){
        var vImgDiceElement = document.getElementById("img-dice");
        var vDivChucMungElement = document.getElementById("div-chuc-mung");
        vDivChucMungElement.style.display = "block";
        var vPChucMungElement = document.getElementById("p-chuc-mung");
        if (paramDice==1){
            vImgDiceElement.src = "LuckyDiceImages/1.png";
            vPChucMungElement.innerHTML = "Chúc bạn may mắn lần sau!"
            vPChucMungElement.style.color = "purple";
        }
        if (paramDice==2){
            vImgDiceElement.src = "LuckyDiceImages/2.png";
            vPChucMungElement.innerHTML = "Chúc bạn may mắn lần sau!"
            vPChucMungElement.style.color = "purple";
        }
        if (paramDice==3){
            vImgDiceElement.src = "LuckyDiceImages/3.png";
            vPChucMungElement.innerHTML = "Chúc bạn may mắn lần sau!"
            vPChucMungElement.style.color = "purple";
        }
        if (paramDice==4){
            vImgDiceElement.src = "LuckyDiceImages/4.png";
            vPChucMungElement.innerHTML = "Chúc mừng bạn hãy chơi tiếp!"
            vPChucMungElement.style.color = "green";
        }
        if (paramDice==5){
            vImgDiceElement.src = "LuckyDiceImages/5.png";
            vPChucMungElement.innerHTML = "Chúc mừng bạn hãy chơi tiếp!"
            vPChucMungElement.style.color = "green";
        }
        if (paramDice==6){
            vImgDiceElement.src = "LuckyDiceImages/6.png";
            vPChucMungElement.innerHTML = "Chúc mừng bạn hãy chơi tiếp!"
            vPChucMungElement.style.color = "green";
        }
    }
    //Hàm xử lý dữ liệu Dice Response
    function handleDiceResponse(paramvXmlHttpDiceRequest){
        console.log(paramvXmlHttpDiceRequest.responseText);
        var vDiceResponse = JSON.parse(paramvXmlHttpDiceRequest.responseText);
        console.log(vDiceResponse);
        var vDice = vDiceResponse.dice;
        console.log("Dice result:= " + vDice);
        //Gọi hàm hiện thị ảnh và lời chúc
        displayChucMung(vDice);
        //Gọi hàm hiện thị voucher
        displayVoucher(vDiceResponse);
        //Gọi hàm hiện thị prize
        displayPrize(vDiceResponse);
    }
    //Hàm kiểm tra dữ liệu nhập vào
    function validateData(paramPersonData){
        var vUserName = paramPersonData.username.trim();
        var vFirstName = paramPersonData.firstname.trim();
        var vLastName = paramPersonData.lastname.trim();
        var vResult = true;
        if (vUserName.length == 0){
            alert("Bạn chưa nhập Username");
            vResult = false;
        }
        else if(vFirstName.length == 0){
            alert("Bạn chưa nhập Firstname");
            vResult = false;
        }
        else if(vLastName.length == 0){
            alert("Bạn chưa nhập Lastname");
            vResult = false;
        }
        return vResult;  
    }
    // Hàm truy xuất dữ liệu
    function getPersonDataFromForm(paramPersonData){
        var vUserNameElement = document.getElementById("input-username");
        var vUserName = vUserNameElement.value;
        var vFirstNameElement = document.getElementById("input-firstname");
        var vFirstName = vFirstNameElement.value;
        var vLastNameElement = document.getElementById("input-lastname");
        var vLastName = vLastNameElement.value;
        paramPersonData.username = vUserName;
        paramPersonData.firstname = vFirstName;
        paramPersonData.lastname = vLastName;   
    }
</script>
</html>